/***
 * Excerpted from "Modern Systems Programming with Scala Native",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/rwscala for more book information.
***/
object main {
  def main(args:Array[String]):Unit = {
    var max = 0
    var max_word = ""
    var max_year = 0

    println("reading from STDIN")
    val read_start = System.currentTimeMillis()
    var lines_read = 0
    for (line <- scala.io.Source.stdin.getLines) {
      val split_fields = line.split("\\s+")

      if (split_fields.size != 4) {
        throw new Exception("Parse Error")
      }

      val word = split_fields(0)
      val year = split_fields(1).toInt
      val count = split_fields(2).toInt

      if (count > max) {
        println(s"found new max: $word $count $year")
        max = count
        max_word = word
        max_year = year
      }
      lines_read += 1
      if (lines_read % 5000000 == 0) {
        val elapsed_now = System.currentTimeMillis() - read_start
        println(s"read $lines_read lines in $elapsed_now ms")
      }
    }
    val read_done = System.currentTimeMillis() - read_start
    println(s"max count: ${max_word}, ${max_year}; ${max} occurrences")
    println(s"$read_done ms elapsed total.")
  }
}
